/*
   The classes in this file provide another demonstration
   of the fact that you must keep separate a reference
   variable from the object it refers to.

   In this example, we instantiate, and use, several objects
   without creating any reference variables. So objects have their
   own existence, without any real need for reference variables.
*/

class SimpleClass1
{
   public String aMethod()
   {
      return("this aMethod in SimpleClass1");
   }
}//SimpleClass1

class SimpleClass2
{
   public String bMethod(SimpleClass1 simpleObject1)
   {
      return("this is bMethod in SimpleClass2 and"
              + "\n\t" + simpleObject1.aMethod() );
   }
}//SimpleClass2


public class AnonymousObjects
{
   public static void main(String[] args)
   {
     System.out.println( (new SimpleClass1()).aMethod() );

     System.out.println( (new SimpleClass2()).bMethod( new SimpleClass1() ) );
   }//main

}//AnonymousObjects