/*
   This class defines an implementation of the abstract Hat class.

   Notice that this implementation of the abstract Hat class
   has only one data field and it is used to encode all
   three of the attributes of a HatB object. The size is put
   in the ones digit of itemKey, the style is put in the tens
   digit, and the color is in the hundreds digit of itemKey.
*/

public class HatB extends Hat
{
   // a single instance field
   private int itemKey;

   // default constructor
   public HatB()
   {
      this(WHITE, BASEBALL, MEDIUM);
   }

   // a full constructor
   public HatB(int size, int style, int color)
   {
      itemKey = color*100 + style*10 + size;
   }

   public void setSize(int size)
   {
      itemKey = getColor()*100 + getStyle()*10 + size;
   }

   public void setStyle(int style)
   {
      itemKey = getColor()*100 + style*10 + getSize();
   }

   public void setColor(int color)
   {
      itemKey = color*100 + getStyle()*10 + getSize();
   }

   public int getSize()
   {
      return itemKey%10;
   }

   public int getStyle()
   {
      return (itemKey%100)/10;
   }

   public int getColor()
   {
      return (itemKey%1000)/100;
   }

}//HatB