/*
   This class implements the HatInterface.
*/

public class HatB implements HatInterface
{
   // a single instance field
   private int itemKey;

   // default constructor
   public HatB()
   {
      this(MEDIUM, BASEBALL, WHITE);
   }

   // a full constructor
   public HatB(int size, int style, int color)
   {
      itemKey = color*100 + style*10 + size;
   }

   public void setSize(int size)
   {
      itemKey = getColor()*100 + getStyle()*10 + size;
   }

   public void setStyle(int style)
   {
      itemKey = getColor()*100 + style*10 + getSize();
   }

   public void setColor(int color)
   {
      itemKey = color*100 + getStyle()*10 + getSize();
   }

   public int getSize()
   {
      return itemKey%10;
   }

   public int getStyle()
   {
      return (itemKey%100)/10;
   }

   public int getColor()
   {
      return (itemKey%1000)/100;
   }

   public String toString()
   {
      // three local variables
      String sizeString, styleString, colorString;

      // use the public interface to get the attributes
      // for an object
      int size = getSize();
      int style = getStyle();
      int color = getColor();

      // determine an appropriate string for the size
      if (size == SMALL) sizeString = "small";
      else if (size == MEDIUM) sizeString = "medium";
      else if (size == LARGE) sizeString = "large";
      else sizeString = "improper"; // should never reach this case!

      // determine an appropriate string for the style
      if (style == BASEBALL) styleString = "baseball";
      else if (style == BEANIE) styleString = "beanie";
      else styleString = "improper"; // should never reach this case!

      // determine an appropriate string for the color
      if (color == WHITE) colorString = "white";
      else if (color == RED) colorString = "red";
      else if (color == BLUE) colorString = "blue";
      else colorString = "improper"; // should never reach this case!

      // return a string that describes an object (notice that the
      // toString() method from the super class is also called)
      return "This is a hat with\n"
           + "\tsize: " + sizeString + "\n"
           + "\tstyle: " + styleString + "\n"
           + "\tcolor: " + colorString + "\n";
   }//toString

}//HatB