/*
   This file defines a class Hat.

   A hat is described by three attributes, size,
   style, and color. These attributes are encoded
   in three integers. Symbolic constants are
   provided for the values that these attributes
   can have.
*/

public class Hat
{
   // three instance fields
   private int size;
   private int style;
   private int color;

   // some size constants
   public static final int SMALL = 1;
   public static final int MEDIUM = 2;
   public static final int LARGE = 3;
   // some style constants
   public static final int BASEBALL = 1;
   public static final int BEANIE = 2;
   // some color constants
   public static final int WHITE = 1;
   public static final int RED = 2;
   public static final int BLUE = 3;

   // default constructor
   public Hat()
   {
      this(MEDIUM, BASEBALL, WHITE);
   }

   // a full constructor
   public Hat(int size, int style, int color)
   {
      this.size = size;
      this.style = style;
      this.color = color;
   }

   public void setSize(int size)
   {
      this.size = size;
   }

   public void setStyle(int style)
   {
      this.style = style;
   }

   public void setColor(int color)
   {
      this.color = color;
   }

   public int getSize()
   {
      return size;
   }

   public int getStyle()
   {
      return style;
   }

   public int getColor()
   {
      return color;
   }

   public String toString()
   {
      // three local variables
      String sizeString, styleString, colorString;

      // determine the appropriate string for the size
      if (size == SMALL) sizeString = "small";
      else if (size == MEDIUM) sizeString = "medium";
      else if (size == LARGE) sizeString = "large";
      else sizeString = "improper"; // should never reach this case!

      // determine the appropriate string for the style
      if (style == BASEBALL) styleString = "baseball";
      else if (style == BEANIE) styleString = "beanie";
      else styleString = "improper"; // should never reach this case!

      // determine the appropriate string for the color
      if (color == WHITE) colorString = "white";
      else if (color == RED) colorString = "red";
      else if (color == BLUE) colorString = "blue";
      else colorString = "improper"; // should never reach this case!

      // return a string that describes this object
      return "size: " + sizeString + "\n"
           + "style: " + styleString + "\n"
           + "color: " + colorString + "\n";
   }

}//Hat