/*
   This class defines an implementation of the
   AbstractGloveItem class.

   This implementation of AbstractGloveItem uses three
   data fields, one for each of the three attributes
   of a GloveItem object.
*/

public class GloveItem extends AbstractGloveItem
{
   // three instance fields
   private int size;
   private int style;
   private int color;

   // default constructor
   public GloveItem()
   {
      this(0, 0, MEDIUM, WOMEN, BLACK);
   }

   // a full constructor
   public GloveItem(int quantity, double price, int size, int style, int color)
   {
      super(quantity, price);
      this.size = size;
      this.style = style;
      this.color = color;
   }

   public void setSize(int size)
   {
      this.size = size;
   }

   public void setStyle(int style)
   {
      this.style = style;
   }

   public void setColor(int color)
   {
      this.color = color;
   }

   public int getSize()
   {
      return size;
   }

   public int getStyle()
   {
      return style;
   }

   public int getColor()
   {
      return color;
   }

}//GloveItem