/*
   This class defines an implementation of the AbstractHatItem class.

   Notice that this implementation of AbstractHatItem
   has only one data field, and it is used to encode
   all three of the attributes of a HatItemB object.
   The size is put in the ones digit of itemKey, the
   style is put in the tens digit, and the color is in
   the hundreds digit of itemKey.
*/

public class HatItemB extends AbstractHatItem
{
   // a single instance field
   private int itemKey;

   // default constructor
   public HatItemB()
   {
      this(0, 0, MEDIUM, BASEBALL, WHITE);
   }

   // a full constructor
   public HatItemB(int quantity, double price, int size, int style, int color)
   {
      super(quantity, price);
      itemKey = color*100 + style*10 + size;
   }

   public void setSize(int size)
   {
      itemKey = getColor()*100 + getStyle()*10 + size;
   }

   public void setStyle(int style)
   {
      itemKey = getColor()*100 + style*10 + getSize();
   }

   public void setColor(int color)
   {
      itemKey = color*100 + getStyle()*10 + getSize();
   }

   public int getSize()
   {
      return itemKey%10;
   }

   public int getStyle()
   {
      return (itemKey%100)/10;
   }

   public int getColor()
   {
      return (itemKey%1000)/100;
   }

}//HatItemB