/*
   This program makes use of the OrderItem class and its subclasses.

   Notice that the toString() method is called polymorphically
   on the entries from the array itemsOrdered[]. If it were not
   for polymorphism, the toString() method called would be the
   one from the OrderItem class. But instead, it is the toString()
   method from the class of the object refered to (GloveItem,
   HatItemA, or HatItemB) that is called.
*/

public class UseOrderItem
{
   public static void main(String[] args)
   {
      // create an array of type OrderItem
      OrderItem[] orderedItems = new OrderItem[4];

      // fill the array with objects of type GloveItem,
      // HatItemA or HatItemB
      orderedItems[0] = new GloveItem(3, 12.95,
                                      GloveItem.MEDIUM, GloveItem.WOMEN, GloveItem.BLACK);
      orderedItems[1] = new GloveItem(1, 14.95,
                                      GloveItem.LARGE, GloveItem.MEN, GloveItem.BROWN);
      orderedItems[2] = new HatItemA(1, 9.95,
                                     HatItemA.LARGE, HatItemA.BASEBALL, HatItemA.RED);
      orderedItems[3] = new HatItemB(1, 9.95,
                                     HatItemB.SMALL, HatItemB.BEANIE, HatItemB.BLUE);

      // print out the items from this order
      for (int i = 0; i < orderedItems.length; i++)
      {
         System.out.println( orderedItems[i].toString() + "\n" );
      }
   }//main

}//UseOrderItem