/*
   This class defines an extension of OrderItem that
   implements the GloveInterface.
*/

public class GloveItem extends OrderItem implements GloveInterface
{
   // three instance fields
   private int size;
   private int style;
   private int color;

   // default constructor
   public GloveItem()
   {
      this(0, 0, MEDIUM, WOMEN, BLACK);
   }

   // a full constructor
   public GloveItem(int quantity, double price, int size, int style, int color)
   {
      super(quantity, price);
      this.size = size;
      this.style = style;
      this.color = color;
   }

   public void setSize(int size)
   {
      this.size = size;
   }

   public void setStyle(int style)
   {
      this.style = style;
   }

   public void setColor(int color)
   {
      this.color = color;
   }

   public int getSize()
   {
      return size;
   }

   public int getStyle()
   {
      return style;
   }

   public int getColor()
   {
      return color;
   }

   public String toString()
   {
      // three local variables
      String sizeString, styleString, colorString;

      // use the public interface to get the attributes
      // for an object
      int size = getSize();
      int style = getStyle();
      int color = getColor();

      // determine an appropriate string for the size
      if (size == SMALL) sizeString = "small";
      else if (size == MEDIUM) sizeString = "medium";
      else if (size == LARGE) sizeString = "large";
      else sizeString = "improper"; // should never reach this case!

      // determine an appropriate string for the style
      if (style == WOMEN) styleString = "women";
      else if (style == MEN) styleString = "men";
      else styleString = "improper"; // should never reach this case!

      // determine an appropriate string for the color
      if (color == BLACK) colorString = "black";
      else if (color == BROWN) colorString = "brown";
      else colorString = "improper"; // should never reach this case!

      // return a string that describes an object (notice that the
      // toString() method from the super class is also called)
      return "This is a glove item with\n"
           + "\tsize: " + sizeString + "\n"
           + "\tstyle: " + styleString + "\n"
           + "\tcolor: " + colorString + "\n"
           + super.toString();
   }//toString

}//GloveItem